package quimufu.colourful_portals.mixin;

import net.minecraft.block.BlockState;
import net.minecraft.registry.Registries;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.BlockPos;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import quimufu.colourful_portals.ColourfulPortalsMod;
import quimufu.colourful_portals.portal.PortalManager;

import static quimufu.colourful_portals.ColourfulPortalsMod.LOGGER;
import static quimufu.colourful_portals.ColourfulPortalsMod.PORTAL_BLOCKS;

@Mixin(ServerWorld.class)
public class BlockChangeMixin {

    @Inject(at = @At("RETURN"), method = "onBlockChanged")
    private void init(BlockPos pos, BlockState oldBlock, BlockState newBlock, CallbackInfo info) {
        ServerWorld world = (ServerWorld) (Object) this;
        if(world.isDebugWorld()|| !world.isChunkLoaded(pos))
            return;
        // This code is injected into the end of ServerWorld.onBlockChanged()V
        if (oldBlock.getBlock() != newBlock.getBlock()) {
            if (PORTAL_BLOCKS.contains(Registries.BLOCK.getId(newBlock.getBlock()))) {
                LOGGER.debug("onBlockNew {} -> {}", oldBlock, newBlock);
                Identifier blockId = Registries.BLOCK.getId(newBlock.getBlock());
                PortalManager.onPortalBlockPlaced(world, pos, blockId);

            }
            if (PORTAL_BLOCKS.contains(Registries.BLOCK.getId(oldBlock.getBlock()))) {
                LOGGER.debug("onBlockOld {} -> {}", oldBlock, newBlock);
                Identifier blockId = Registries.BLOCK.getId(oldBlock.getBlock());
                PortalManager.onPortalBlockBroken(world, pos, blockId);
            }
        }

    }
}